package com.b510.action;

import com.b510.domain.Emailverificationcode;
import com.b510.service.EmailVerificationCodeService;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

/**
 * 
 * @author Hongten
 * 
 */
public class EmailVerificationCodeAction extends ActionSupport {

	/**
	 * identification number
	 */
	private static final long serialVersionUID = 1514692413102258755L;

	/**
	 * ¼ʱдemail
	 */
	private String email;
	/**
	 * ¼ʱдpassword
	 */
	private String password;
	/**
	 * id
	 */
	private int id;
	/**
	 * Ƿ񼤻
	 */
	private int active;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getActive() {
		return active;
	}

	public void setActive(int active) {
		this.active = active;
	}

	/**
	 * ¼ʱд֤
	 */
	private String verificationCode;
	/**
	 * ͨspringIoCʽעEmailVerificationCodeServiceһʵ
	 */
	private EmailVerificationCodeService emailVerificationCodeService;

	@Override
	public String execute() throws Exception {
		// emailpasswordΪnullʱִе¼
		if (getEmail() != null && getPassword() != null) {
			Emailverificationcode emailVerificationCode = new Emailverificationcode();
			emailVerificationCode = getEmailVerificationCodeService()
					.getByEmailAndPassword(getEmail(), getPassword());
			if (emailVerificationCode.getActive() == 0) {
				return "error";
			} else {
				String verificationCode = getEmailVerificationCodeService()
						.getRandomChar()
						+ getEmailVerificationCodeService().getRandomChar()
						+ getEmailVerificationCodeService().getRandomChar()
						+ getEmailVerificationCodeService().getRandomChar();
				String content = "֤ǣ" + verificationCode;
				// ActionContextʵ
				ActionContext ctx = ActionContext.getContext();
				// ȡHttpSessionеverificationCode
				ctx.getSession().put("verificationCode", verificationCode);
				getEmailVerificationCodeService()
						.sendEmail(
								getEmail(),
								EmailVerificationCodeService.SUBJECT_MAIL_GETVERIFICATIONCODE,
								content);
				return "input";
			}
		}
		return "error";
	}

	public String getEmail() {
		return email;
	}

	public EmailVerificationCodeService getEmailVerificationCodeService() {
		return emailVerificationCodeService;
	}

	public String getPassword() {
		return password;
	}

	public String getVerificationCode() {
		return verificationCode;
	}

	// ֤
	public String inputVerificationCode() throws Exception {
		// ActionContextʵ
		ActionContext ctx = ActionContext.getContext();
		// ȡHttpSessionеverificationCode
		String ver = (String) ctx.getSession().get("verificationCode");

		// verificationCodeΪnullʱִе¼
		if (getVerificationCode() != null
				&& getVerificationCode().equalsIgnoreCase(ver)) {
			return SUCCESS;
		} else {
			return "errorVerCode";
		}
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public void setEmailVerificationCodeService(
			EmailVerificationCodeService emailVerificationCodeService) {
		this.emailVerificationCodeService = emailVerificationCodeService;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public void setVerificationCode(String verificationCode) {
		this.verificationCode = verificationCode;
	}

	public String login() throws Exception {
		return "login";
	}

}
