package com.b510.dao.impl;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.b510.dao.EmailVerificationCodeDAO;
import com.b510.domain.Emailverificationcode;

public class EmailVerificationCodeDAOImpl extends HibernateDaoSupport implements
		EmailVerificationCodeDAO {

	@SuppressWarnings("unchecked")
	public Emailverificationcode getByEmailAndPassword(String email,
			String password) {
		List<Emailverificationcode> evc = (List<Emailverificationcode>) getHibernateTemplate()
				.find(
						"from Emailverificationcode where email=? and password=?",
						email, password);
		if (evc != null && evc.size() >= 1) {
			return evc.get(evc.size() - 1);
		}
		return null;
	}

	public Emailverificationcode getById(int id) {
		return getHibernateTemplate().get(Emailverificationcode.class, id);
	}

	public void save(Emailverificationcode emailVerificationCode) {
		getHibernateTemplate().save(emailVerificationCode);
	}

	public int updateActive(Emailverificationcode emailverificationcode) {
		getHibernateTemplate().update(emailverificationcode);
		return 1;
	}

	public Emailverificationcode getByEmailAndPassword(String email,
			String password, int active) {
		return (Emailverificationcode) getHibernateTemplate()
				.find(
						"from Emailverificationcode as e where e.email=? and e.password=? and e.active=?",
						new Object[] { email, password, active });
	}

}
