package com.b510.service.impl;

import java.io.IOException;
import java.net.UnknownHostException;

import com.b510.dao.EmailVerificationCodeDAO;
import com.b510.domain.Emailverificationcode;
import com.b510.service.EmailVerificationCodeService;
import com.b510.utils.MailMessage;
import com.b510.utils.SendEmail;

public class EmailVerificationCodeServiceBean implements
		EmailVerificationCodeService {
	/**
	 * ͨspringIoCעEmailVerificationCodeDAOһʵ
	 */
	private EmailVerificationCodeDAO emailVerificationCodeDAO;

	/**
	 * ʼһʵ
	 */
	private SendEmail sendEmail;

	public Emailverificationcode getByEmailAndPassword(String email,
			String password) {

		return getEmailVerificationCodeDAO().getByEmailAndPassword(email,
				password);
	}
	public Emailverificationcode getById(int id) {
		return getEmailVerificationCodeDAO().getById(id);
	}

	public EmailVerificationCodeDAO getEmailVerificationCodeDAO() {
		return emailVerificationCodeDAO;
	}

	public SendEmail getSendEmail() {
		return sendEmail;
	}

	public void save(Emailverificationcode emailVerificationCode) {
		getEmailVerificationCodeDAO().save(emailVerificationCode);
	}

	public void setEmailVerificationCodeDAO(
			EmailVerificationCodeDAO emailVerificationCodeDAO) {
		this.emailVerificationCodeDAO = emailVerificationCodeDAO;
	}

	public void setSendEmail(SendEmail sendEmail) {
		this.sendEmail = sendEmail;
	}

	public int updateActive(Emailverificationcode emailverificationcode) {
		return getEmailVerificationCodeDAO().updateActive(emailverificationcode);
	}
	/**
	 * 
	 */
	public void sendEmail(String toMail,String subject,String content){
		MailMessage message = new MailMessage();
		message.setFrom(EmailVerificationCodeService.FROM_MAIL);// 
		message.setTo(toMail);// ռ
		String server = EmailVerificationCodeService.SERVER_MAIL;// ʼ
		message.setSubject(subject);// ʼ
		message.setContent(content);// ʼ
		message.setDatafrom(EmailVerificationCodeService.DATAFROM_MAIL);// ˣʼķĿʾ
		message.setDatato(toMail);// ռˣʼռĿʾ
		message.setUser(EmailVerificationCodeService.USER_MAIL);// ½û
		message.setPassword(EmailVerificationCodeService.PASSWORD_MAIL);// ½

		SendEmail smtp;
		try {
			smtp = new SendEmail(server, 25);
			boolean flag;
			flag = smtp.sendMail(message, server);
			if (flag) {
				System.out.println("ʼͳɹ");
			} else {
				System.out.println("ʼʧܣ");
			}
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		
	}
	public Emailverificationcode getByEmailAndPassword(String email,
			String password, int active) {
		return getEmailVerificationCodeDAO().getByEmailAndPassword(email,
				password,active);
	}
	// ȡַ
	public String getRandomChar() {
		// һ012
		int rand = (int) Math.round(Math.random() * 2);
		long itmp = 0;
		char ctmp = '\u0000';
		switch (rand) {
		// ɴдĸ
		case 1:
			itmp = Math.round(Math.random() * 25 + 65);
			ctmp = (char) itmp;
			return String.valueOf(ctmp);
			// Сдĸ
		case 2:
			itmp = Math.round(Math.random() * 25 + 97);
			ctmp = (char) itmp;
			return String.valueOf(ctmp);
			// 
		default:
			itmp = Math.round(Math.random() * 9);
			return itmp + "";
		}
	}
}
