package com.b510.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.StringTokenizer;

import sun.misc.BASE64Encoder;

public class SendEmail {
	public SendEmail() {
	}

	private boolean debug = true;
	BASE64Encoder encode = new BASE64Encoder();// ڼܺû

	private Socket socket;

	public SendEmail(String server, int port) throws UnknownHostException,
			IOException {
		try {
			socket = new Socket(server, 25);
		} catch (SocketException e) {
			System.out.println(e.getMessage());
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			System.out.println("Ѿ!");
		}
	}

	// עᵽʼ
	public void helo(String server, BufferedReader in, BufferedWriter out)
			throws IOException {
		int result;
		result = getResult(in);

		// ʼ,220Ӧ
		if (result != 220) {
			throw new IOException("ӷʧ");
		}

		result = sendServer("HELO " + server, in, out);

		// HELOɹ󷵻250
		if (result != 250) {
			throw new IOException("עʼʧܣ");
		}
	}

	private int sendServer(String str, BufferedReader in, BufferedWriter out)
			throws IOException {
		out.write(str);
		out.newLine();
		out.flush();

		if (debug) {
			System.out.println("ѷ:" + str);
		}

		return getResult(in);
	}

	public int getResult(BufferedReader in) {
		String line = "";

		try {
			line = in.readLine();
			if (debug) {
				System.out.println("״̬:" + line);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		// ӷϢж״̬,ת
		StringTokenizer st = new StringTokenizer(line, " ");

		return Integer.parseInt(st.nextToken());
	}

	public void authLogin(MailMessage message, BufferedReader in,
			BufferedWriter out) throws IOException {
		int result;
		result = sendServer("AUTH LOGIN", in, out);

		if (result != 334) {
			throw new IOException("û֤ʧܣ");
		}
		result = sendServer(encode.encode(message.getUser().getBytes()), in,
				out);

		if (result != 334) {
			throw new IOException("û");
		}
		result = sendServer(encode.encode(message.getPassword().getBytes()),
				in, out);

		if (result != 235) {
			throw new IOException("֤ʧܣ");
		}
	}

	// ʼϢʼԴַ
	public void mailfrom(String source, BufferedReader in, BufferedWriter out)
			throws IOException {
		int result;
		result = sendServer("MAIL FROM:<" + source + ">", in, out);

		if (result != 250) {
			throw new IOException("ָԴַ");
		}
	}

	// ʼռ
	public void rcpt(String touchman, BufferedReader in, BufferedWriter out)
			throws IOException {
		int result;
		result = sendServer("RCPT TO:<" + touchman + ">", in, out);

		if (result != 250) {
			throw new IOException("ָĿĵַ");
		}
	}

	// ʼ
	public void data(String from, String to, String subject, String content,
			BufferedReader in, BufferedWriter out) throws IOException {
		int result;
		result = sendServer("DATA", in, out);

		// dateس,յ354Ӧ,ʼ
		if (result != 354) {
			throw new IOException("ܷ");
		}

		out.write("From: " + from);
		out.newLine();
		out.write("To: " + to);
		out.newLine();
		out.write("Subject: " + subject);
		out.newLine();
		out.newLine();
		out.write(content);
		out.newLine();

		// ӻسʼ
		result = sendServer(".", in, out);
		System.out.println(result);

		if (result != 250) {
			throw new IOException("ݴ");
		}
	}

	// ˳
	public void quit(BufferedReader in, BufferedWriter out) throws IOException {
		int result;
		result = sendServer("QUIT", in, out);

		if (result != 221) {
			throw new IOException("δȷ˳");
		}
	}

	// ʼ
	public boolean sendMail(MailMessage message, String server) {
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(socket
					.getInputStream()));
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(
					socket.getOutputStream()));
			helo(server, in, out);// helo
			authLogin(message, in, out);// auth login
			mailfrom(message.getFrom(), in, out);// mail from
			rcpt(message.getTo(), in, out);// rcpt to
			data(message.getDatafrom(), message.getDatato(), message
					.getSubject(), message.getContent(), in, out);// DATA
			quit(in, out);// quit
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
}
